import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class fassade_teammc extends PApplet {
float xmag = 0, ymag = 0, scl = 30.0f;
float newXmag = 0, newYmag = 0; 
int l = 40, w = 20, h = 30;
int num;
boolean paused = false;
boolean stopped = false;
float sizexy = 0.2f, sizez = 0.2f;
PFont font;

int themecolors[];
int themespeed[] = {0,0,0};

Window windows[];
Itheme theme[];


public void setup()
{
  size(640, 480, P3D);
  windows = new Window[1];
  rectMode(CENTER);
  noStroke();
  background(10, 10, 23);
  frameRate(18);
  theme = new Itheme[3];
  themecolors = new int[3];
  themecolors[0] = color(255,255,0);
  themecolors[1] = color(255,0,0);
  themecolors[2] = color(0,255,0);
  font = loadFont("HelveticaNeue-CondensedBold-48.vlw");
  textFont(font, 12);
  if(!createWindows())
  {
      exit();
  }
}



public void draw()
{
  background(10, 10, 23);
  pushMatrix(); 
  camera();
  //lights();
  for(int i = 0; i < theme.length; ++i)
    if(theme[i] != null)
      theme[i].update(paused);
  beginShape(QUADS);
  for(int i = 0; i < num; ++i)
  {
    windows[i].updglow(paused);
    windows[i].draw();
  }
  fill(100,110,100);
  vertex(-l*sizexy/2,-w*sizexy/2,-h*sizez/2); vertex(l*sizexy/2,-w*sizexy/2,-h*sizez/2); vertex(l*sizexy/2,w*sizexy/2,-h*sizez/2); vertex(-l*sizexy/2,w*sizexy/2,-h*sizez/2);
  fill(100,110,100);
  vertex(-l*sizexy/2,-w*sizexy/2,h*sizez/2); vertex(l*sizexy/2,-w*sizexy/2,h*sizez/2); vertex(l*sizexy/2,w*sizexy/2,h*sizez/2); vertex(-l*sizexy/2,w*sizexy/2,h*sizez/2);
  endShape();
  popMatrix();
  if(stopped)
  {
    fill(255);
    text("Stop", 10, 10);  
  }
  else if(paused)
  {
    fill(255);
    text("Pause", 10, 10);  
  }
  
  float sec = PApplet.parseFloat(frameCount) / frameRate;
  if(sec <  8.0f)
  {
    int a = 255;
    if(sec >  5.0f)
    {
      a = 255-PApplet.parseInt((sec - 5.0f)/3.0f*255.0f);
    }
    fill(255,255,255,a);
    text(".:: TeamMC ::.", 10, 10);
  }
  //else
  {
    
    for(int i = theme.length-1; i >= 0; --i)
    {
      fill(themecolors[i]);
      if(theme[i] != null)
      {
        String txt = theme[i].getname() + " ";
        for(int j = 0; j <= themespeed[i]; ++j)
          txt = txt + "+";
        text(txt, 10, height-10-14*(theme.length-1-i));
      }
      else
        text("<.....>", 10, height-10-14*(theme.length-1-i));
    }
  }
  //controlP5.draw();
}

public void keyPressed()
{
  //l -=1;
  //w +=1;
  if(key == '1')
  {
    if(!changeTheme("next",0))
        println("changeTheme fehlgeschlagen");
  }
  else if(key == '2')
  {
    if(!changeTheme("next",1))
        println("changeTheme fehlgeschlagen");
  }
  else if(key == '3')
  {
    if(!changeTheme("next",2))
        println("changeTheme fehlgeschlagen");
  }
  else if(key == '4')
  {
    ++themespeed[0];
    themespeed[0] %= 3;
    if(theme[0] != null)
      theme[0].setspeed(themespeed[0]);
  }
  else if(key == '5')
  {
    ++themespeed[1];
    themespeed[1] %= 3;
    if(theme[1] != null)
      theme[1].setspeed(themespeed[1]);
  }
  else if(key == '6')
  {
    ++themespeed[2];
    themespeed[2] %= 3;
    if(theme[2] != null)
      theme[2].setspeed(themespeed[2]);
  }
  else if(keyCode == LEFT)
  {
    sizexy -= .025f;
    createWindows();
  }
  else if(keyCode == RIGHT)
  {
    sizexy += .025f;
    createWindows();
  }
  else if(keyCode == UP)
  {
    sizez += .025f;
    createWindows();
  }
  else if(keyCode == DOWN)
  {
    sizez -= .025f;
    createWindows();
  }
  
  else if(key == ' ')
  {
    if(paused)
    {
      if(stopped)
      {
        stopped = false;
        paused = false;
      }
      else
        stopped = true;
    }
    else
      paused = true;
  }
  else if(key == 'w')
  {
    h+=1;
    createWindows();
  }
  else if(key == 's')
  {
    h-=1;
    createWindows();
  }
  else if(key == 'a')
  {
    l+=1;
    createWindows();
  }
  else if(key == 'd')
  {
    l-=1;
    createWindows();
  }
  else if(key == 'q')
  {
    w+=1;
    createWindows();
  }
  else if(key == 'e')
  {
    w-=1;
    createWindows();
  }
  //createWindows();
}





public void camera()
{
  translate(width/2, height/2, -30);
  if(!stopped)
  {
    if(mousePressed)
    {
      scl += (mouseY - pmouseY) / 3.0f;
    }
    else
    {
      newXmag = mouseX/PApplet.parseFloat(width) * TWO_PI;
      newYmag = mouseY/PApplet.parseFloat(height) * TWO_PI;
      float diff = xmag-newXmag;
      if (abs(diff) >  0.01f) { xmag -= diff/4.0f; }

      diff = ymag-newYmag;
      if (abs(diff) >  0.01f) { ymag -= diff/4.0f; }
    }
  }
  rotateX(-ymag/4.2f+PI/1.8f); 
  rotateZ(-xmag-PI/3.0f);
  scale(scl);
}

public boolean changeTheme(String name, int it)
{
  if(it > theme.length)
    return false;
  if(theme[it] == null)
  {
    name = themeList[0];
  }
  if(name == "next")
  {
    int l = themeList.length;
    for(int i=0; i < l; ++i)
    {
        if(theme[it].getname() == themeList[i])
        {
          i++;
          if(i >= l)
          {
            i = 0;
            name = "none";
          }
          else
            name = themeList[i];
          break;
        }
    }
  }
  boolean success = false;
  for(int i = 0; i < num; ++i)
    windows[i].stopglow(it);
  
  if(name == "themeOne")
  {
     theme[it] = new themeOne(themecolors[it],it);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "themeRandom")
  {
     theme[it] = new themeRandom(themecolors[it], it, num / 18);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "themeH1")
  {
     theme[it] = new themeH1(themecolors[it], it);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "themeH5")
  {
     theme[it] = new themeH5(themecolors[it], it);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "themeV1")
  {
     theme[it] = new themeV1(themecolors[it], it);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "themeV5")
  {
     theme[it] = new themeV5(themecolors[it], it);
     theme[it].start(themespeed[it]);
     success = true;
  }
  else if(name == "none")
  {
    theme[it] = null;
    success = true;
  }

  return success;
}
public int getnb(int i, int dir, boolean flipv)
{
  int totlen = 2*(w+l);
  int row = i / totlen;
  int spl = i % totlen;
  dir %= 4;
  if(dir == 0)
  {
    spl--;
    if(spl < 0)
      spl = totlen - 1;
  }
  else if(dir == 1)
  {
    row++;
    if(row >= h)
    {
      if(!flipv)
        return -1;
      row = 0;
    }
  }
  else if(dir == 2)
  {
    spl++;
    if(spl >= totlen)
      spl = 0;
  }
  else if(dir == 3)
  {
    row--;
    if(row < 0)
    {
      if(!flipv)
        return -1;
      row = h-1;
    }
  }
  return row*totlen + spl;
}

public int getleft(int i)
{
  return getnb(i, 0, false);
}

public int getup(int i)
{
  return getnb(i, 1, false);
}

public int getright(int i)
{
  return getnb(i, 2, false);
}

public int getdown(int i)
{
  return getnb(i, 3, false);
}

public boolean createWindows()
{
  num = (l+w)*2*h;
  println("Anzahl Fenster: "+num);
  if(num > 10000)
  {
    println("Mehr als 10000 Fenster. Programm wird beendet");
    return false;
  }
  windows = new Window[num];
  int totlen = 2*(w+l);
  float x = -l*sizexy/2, y = -w*sizexy/2;
  float s[] = {sizexy, sizez};
  for(int i = 0; i < num; ++i)
  {
    int row = i / totlen;
    int spl = i % totlen;
    float dx, dy;
    if(spl < l) 
    {
      dx = sizexy;
      dy = 0.0f;
      s[0] = sizexy;
    }
    else if(spl >= l+w && spl < 2*l+w)
    {
      dx = -sizexy;
      dy = 0.0f; 
      s[0] = -sizexy;
    }
    else if(spl >= l && spl < l+w)
    {
      dx = 0.0f;
      dy = sizexy;
      s[0] = sizexy;
    }
    else
    {
      dx = 0.0f;
      dy = -sizexy;
      s[0] = -sizexy;
    }
    
    float p[] = {x,y,row*sizez-sizez*h/2};
    int gs = PApplet.parseInt(PApplet.parseFloat(row) / PApplet.parseFloat(h) * 128) + (i%2 * 10);
    windows[i] = new Window(s, p, dx == 0.0f, color(gs + 64, gs + 64, gs + 100));
    x += dx;
    y += dy;
  }
  
  for(int i = 0; i < 3; ++i)
  {
     if(theme[i] != null)
      theme[i].start(themespeed[i]); 
  }
  return true;
}


String themeList[] = {"themeOne", "themeRandom", "themeH1", "themeH5", "themeV1", "themeV5"};

abstract class Itheme
{
  Itheme(int _col, int i)
  {
    running = false;
    col = _col;
    ix = i;
    name = "<unkown>";
    speed = 1;
  }
  abstract public boolean start(int _speed);
  abstract public boolean update(boolean paused);
  public boolean hasfinished()
  {
    return running;  
  }
  public String getname()
  {
    return name;
  }
  
  public void setspeed(int _speed)
  {
    speed = PApplet.parseFloat(_speed % 3)/2.0f + 1.0f;
  }
  
  protected boolean running;
  protected String name;
  protected int col;
  protected int ix;
  protected float speed;
}

class themeOne extends Itheme
{
  int dev;
  themeOne(int _col, int i)
  {
    super(_col, i);
    name = "themeOne";
    dev = PApplet.parseInt(random(4));
  }
  public boolean start(int _speed)
  {
    setspeed(_speed);
    running = true;
    return true;
  }
  public boolean update(boolean paused)
  {
    if(paused)
      return true;
    
    for(int i = 0; i < num; ++i)
    {
      if(i%(9+second()%10+dev)/speed == 0 && !paused)
        windows[i].glow(col, .33f, 2.0f/speed, 0.5f/speed, ix);
    }
    
    return true;
  }
}

class themeRandom extends Itheme
{
  float nps, npf, rnpf;
  
  themeRandom(int _col, int i, float npersec)
  {
    super(_col, i);
    name = "themeRandom";
    nps = npersec;
  }
  public boolean start(int _speed)
  {
    setspeed(_speed);
    running = true;
    return true;
  }
  public boolean update(boolean paused)
  {
    if(paused)
      return true;
    npf = nps / frameRate * speed;
    rnpf = 1.0f / npf;
    if(npf < 1.0f && PApplet.parseInt(random(rnpf)) == 1)
    {
      windows[PApplet.parseInt(random(num))].glow(col, .33f, (2.0f+random(4.0f))/speed, 1.0f/speed, ix);
    }
    else
    {
      for(int i = 0; i < npf; ++i)
      {
        windows[PApplet.parseInt(random(num))].glow(col, .33f, (2.0f+random(4.0f))/speed, 1.0f/speed, ix);
      }
      
    }
    return true;
  }
}

class themeVhBase extends Itheme
{
  boolean vertical;
  int nbright;
  int n, len, nupd, updr;
  float dir;
  int pos[];
  themeVhBase(int _col, int i, boolean _vertical, int _nbright)
  {
    super(_col, i);
    name = "themeVhBase";
    vertical = _vertical;
    nbright = _nbright;
    n = 1;
    dir = 1.0f;
  }
  public boolean start(int _speed)
  {
    setspeed(_speed);
    if(vertical)
    {
      len = h;
      n = h / (8 + 3*nbright);
    }
    else
    {
      len = 2*(w+l);
      n = len / (12 + 3*nbright);
    }
    if(n <= 0)
      n = 1;
    if(PApplet.parseInt(random(2)) == 1)
      dir = 1.0f;
    else
      dir = -1.0f;
    pos = new int[n];
    for(int i = 0; i < n; ++i)
    {
      int dst = len / n;
      pos[i] = i*dst + PApplet.parseInt(random(dst/2));
    }
    updr = PApplet.parseInt(frameRate / 2.0f);
    nupd = frameCount + PApplet.parseInt(updr / speed);
    running = true;
    return true;
  }
  public boolean update(boolean paused)
  {
    if(paused)
      return true;
    if(nupd <= frameCount)
    {
      for(int i = 0; i < n; ++i)
      {
        boolean isnew = false;
        if(dir > 0.0f)
        {
          ++pos[i];
          isnew = true;
          if(pos[i] >= len)
            pos[i] = 0;
        }
        else
        {
          --pos[i];
          isnew = true;
          if(pos[i] < 0)
            pos[i] = len - 1;
        }
        
        if(isnew)
        {
          float fifofa = PApplet.parseFloat(nbright)/1.0f;
          if(fifofa < 1.0f)
            fifofa = 1.0f;
          if(vertical)
          {
            int nw = 2*(w+l);
            int ph = nw * pos[i];
            for(int j = 0; j < nw; ++j)
            {
              windows[j+ph].glow(col, .33f, nbright*1.5f/speed, .5f/speed*fifofa, ix);
            }
          }
          else
          {
            int nw = 2*(w+l);
            for(int j = 0; j < h; ++j)
            {
              windows[pos[i]+j*nw].glow(col, .33f, nbright*1.5f/speed, .5f/speed*fifofa, ix);
            }
          }
          
          updr = PApplet.parseInt(frameRate / 2.0f);
          nupd = frameCount + PApplet.parseInt(updr / speed);
        }
        
      }
    }
    return true;
  }
}

class themeH1 extends themeVhBase
{
  themeH1(int _col, int i)
  {
    super(_col, i, false, 1);
    name = "themeH1";
  }
}

class themeH5 extends themeVhBase
{
  themeH5(int _col, int i)
  {
    super(_col, i, false, 5);
    name = "themeH5";
  }
}

class themeV1 extends themeVhBase
{
  themeV1(int _col, int i)
  {
    super(_col, i, true, 1);
    name = "themeV1";
  }
}

class themeV5 extends themeVhBase
{
  themeV5(int _col, int i)
  {
    super(_col, i, true, 5);
    name = "themeV5";
  }
}

public class Window
{
  public Window(float _size[], float _pos[], boolean _yrot, int _color)
  {
    set(_size, _pos, _yrot, _color); 
  }
  
  public void set(float _size[], float _pos[], boolean _yrot, int _color)
  {
    size = new float[2];
    pos = new float[3];
    System.arraycopy(_size, 0, size, 0, 2);
    System.arraycopy(_pos, 0, pos, 0, 3);
    yrot = _yrot;
    col = _color;
    acol = col;
    g= new Glow[3];
    for(int i=0; i <3; ++i)
      g[i]=new Glow();
  }
  
  public void set_color(int _color)
  {
    col = _color;
    //if(!gstarted)
      acol = col;
  } 
  
  public boolean draw()
  {
    fill(acol);
    if(yrot)
    {
      vertex(pos[0], pos[1], pos[2]);
      vertex(pos[0], pos[1] + size[0], pos[2]);
      vertex(pos[0], pos[1] + size[0], pos[2] + size[1]);
      vertex(pos[0], pos[1], pos[2] + size[1]);
    }
    else
    {
      vertex(pos[0], pos[1], pos[2]);
      vertex(pos[0] + size[0], pos[1], pos[2]);
      vertex(pos[0] + size[0], pos[1], pos[2] + size[1]);
      vertex(pos[0], pos[1], pos[2] + size[1]);
    }
    return true; 
  }
  
  public void glow(int col, float intensity, float t, float t100, int i)
  {
    g[i%3].start(col, intensity, t, t100);
  }
  
  public void stopglow(int i)
  {
    g[i%3].stop();
  }

  
  public void updglow(boolean pause)
  {
    int cb = 0;
    int c[] = new int[3];
    for(int i=0; i<3; ++i)
    {
      c[i] = g[i].update(pause);
    }
    if(alpha(c[0]) > 0 && alpha(c[0]) > 0)
      cb = blendColor(c[0],c[1],BLEND);
    else if(alpha(c[0]) == 0)
      cb = c[1];
    else if(alpha(c[1]) == 0)
      cb = c[0];
    if (alpha(c[2]) > 0)
      cb = blendColor(c[2],cb,BLEND);
    acol = blendColor(col, cb, BLEND);
    acol = color(red(acol), green(acol), blue(acol), 255);

      //acol = color(red(col)*(1.0-p)+red(gcol)*p,green(col)*(1.0-p)+green(gcol)*p,blue(col)*(1.0-p)+blue(gcol)*p);
      //acol = blendColor(color(red(col),green(col), blue(col), (1.0-p)*255), color(red(gcol),green(gcol), blue(gcol), (p)*255), BLEND);
      //acol = color(red(acol), green(acol), blue(acol), 255);
  }
  
  private float size[];
  private float pos[];
  private boolean yrot;
  private int col;
  private int acol;
  private Glow g[];
  
  class Glow
  {
    Glow()
    {  
      gstarted = false;
    }
    public void start(int col, float intensity, float t, float t100)
    {
      if(gstarted)
        return;
      gstarted = true;
      gstartt = frameCount;
      gt = PApplet.parseInt(frameRate * t + .5f);
      gendt = frameCount + gt;
      gcol = col;
      gint = intensity;
      gt100 = PApplet.parseInt(t100 * frameRate + 0.5f);
      if(2*gt100 > gt)
        gt100 = gt/2;
      if(gint > 1.0f)
        gint = 1.0f;
    }
    public void stop()
    {
      gstarted = false;
    }
    public int update(boolean pause)
    {
      if(pause)
      {
        gendt++;
        gstartt++;
        return lcol;
      }
      if(!gstarted)
      {
        lcol = 0;
        return 0;
      }
      if(frameCount > gendt)
      {
        gstarted = false;
        lcol = 0;
        return 0;
      }
      int dt = frameCount - gstartt;
      if(dt < gt100 || dt > gt - gt100)
      {
        float p;
        if(dt < gt100)
        {
          p = PApplet.parseFloat(dt) / PApplet.parseFloat(gt100) * gint;
        }
        else
        {
          p = PApplet.parseFloat(dt - gt + gt100) / PApplet.parseFloat(gt100) * gint;
          p = gint - p;
        }
        lcol = color(red(gcol),green(gcol), blue(gcol), (p)*255);
        return lcol;
      }
      lcol = color(red(gcol),green(gcol), blue(gcol), gint*255);
      return lcol;
    }
    private boolean gstarted;
    private int gstartt;
    private int gendt;
    private int gt;
    private int gt100;
    private int gcol, lcol;
    private float gint;
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "fassade_teammc" });}}